/******************************************************************************
*@file  : app.h
*@brief : header file
******************************************************************************/
#ifndef __APP_H__
#define __APP_H__

#include "hal.h"
#include "acm32g103_coreboard.h" 

typedef enum
{
    TEST_UART1_LOOP,
    TEST_UART1_IT,
    TEST_UART1_DMA,
	TEST_UART2,
	TEST_UART3,
    TEST_UART4
}enum_TEST_MODE_t;

/*--------------------extern vars-----------------*/

extern UART_HandleTypeDef  UART1_Handle;
extern UART_HandleTypeDef  UART2_Handle;
extern UART_HandleTypeDef  UART3_Handle;
extern DMA_HandleTypeDef  DMA_CH1_Handle;
extern DMA_HandleTypeDef  DMA_CH2_Handle;
/*---------------------functions------------------*/

void UART1_Init(void);
void UART2_Init(void);
void UART3_Init(void);

/* APP_Uart_Test */
void APP_Uart_Test(enum_TEST_MODE_t fe_Mode);

#endif
